#include <cstdlib>
#include <cstring>
#include <iostream>

#include "storybook.h"

Storybook::Storybook(FILE* fin) {
  pages = CyoaParse(fin);
}

void Storybook::Find(const char* id) {
  for (Page* page : pages) {
    if (strcmp(page->id, id) == 0) {
      current = page;
      return;
    }
  }
  // If not found
  current = NULL;
}

void print_choice(Choice* c) {
  printf("%d) %s", c->option, c->flavor);
  if (c->statcheck) {
    printf("(%s %d%c)",
	   c->statcheck->stat,
	   c->statcheck->value,
	   c->statcheck->rel == STATCHECK_GT ? '+' : '-');
  }
  printf("\n");
}

void Storybook::Play() {
  printf(current->body);

  switch (current->footer.type) {
  case FooterType::End:
    printf("The End.");
    IsEnded = true;
    break;
  case FooterType::Goto:
    Find(current->footer.link);
    printf("Press ENTER to continue...");
    std::cin.get();
    break;
  case FooterType::Choices:
    for (auto c : *current->footer.choices) {
      print_choice(c.second);
    }
    printf("Make a selection: ");
    int choice;
    std::cin >> choice;
    Find((*current->footer.choices)[choice]->id);
    break;
  default:
    IsEnded = true; // TODO
  }
}
